import nx_utils as util

# Example graphs from class notes
sampleGraph1 = {1:[2,3,4], 2:[1,3,5], 3:[1,2], 4:[1,7,9], 5:[2,9], 6:[9], 7:[4], 8:[9], 9:[5,8,6,4]}
sampleGraph2 = {1:[2,3,4], 2:[1,3,5], 3:[1,2], 4:[1,7,9], 5:[2,9], 6:[9], 7:[4], 8:[9], 9:[5,8,6,4], 10:[11, 12], 11:[10], 12:[10]}

# util.plot_graph(sampleGraph1, "SampleGraph1")
# util.plot_graph(sampleGraph2, "SampleGraph2")


# A global set to store which nodes have been visited by dfs().
# This needs to be initialized before each call to dfs().
visited = set()

def dfs(graph,source,target):
    """Returns the target node, if it is connected to the source node in the graph; otherwise returns None."""
    if source in visited:
        # Already been here.  Don't try again.
        print "Been here already: ", source
        return None

    else:
        print "We're at node",source

        # Remember that we've come here.
        visited.add(source)

        if source == target:
            # Found it!  We're done.
            print "Found target = ", target
            return target

        else:
            # Keep looking from where we're at.
            print "Searching node ", source, " neighbors: ", graph[source]
            for node in graph[source]:
                result = dfs(graph,node,target)  # recurse

                if result != None:
                    # Found it!  We're done.
                    print "Found result = ", result
                    return result
                else:
                    print "No path found from ",node," to ", target 

            # Not reachable from here via any edge.
            print "Can't find it in: ", graph[source]
            return None
    
